﻿Option Explicit On
Option Strict On

Imports System.Windows.Forms

Public Class Form1

    ''' <summary>
    ''' API-Deklaration
    ''' </summary>
    Private Declare Function GetAsyncKeyState Lib "user32.dll" ( _
        ByVal vKey As Keys) As Short

    Private Sub Form1_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        ' Notwendig, wenn sich Steuerelemente auf dem Form befinden
        Me.KeyPreview = True
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        Select Case True

            Case GetAsyncKeyState(Keys.LShiftKey) <> 0
                Me.Text = "Linke Umschalt-Taste"

            Case GetAsyncKeyState(Keys.RShiftKey) <> 0
                Me.Text = "Rechte Umschalt-Taste"

            Case GetAsyncKeyState(Keys.LMenu) <> 0
                Me.Text = "Linke Alt-Taste"

                ' Da die AltGr-Taste eine Kombination der linke Umschalt-Taste
                '  plus der linken Alt-Taste auslöst, muß AltGr immer vor der 
                '  Überprüfung auf die linke Strg-Taste abgefragt werden, da 
                '  sie andernfalls nicht korrekt erkannt wird. Die Abfrage-
                '  Reihenfolge aller übrigen Modifizierer-Tasten ist beliebig 
                '  und beeinflußt nicht die korrekte Erkennung.
            Case GetAsyncKeyState(Keys.ControlKey) <> 0 AndAlso _
                 GetAsyncKeyState(Keys.RMenu) <> 0
                Me.Text = "AltGr-Taste"

            Case GetAsyncKeyState(Keys.LControlKey) <> 0
                Me.Text = "Linke Strg-Taste"

            Case GetAsyncKeyState(Keys.RControlKey) <> 0
                Me.Text = "Rechte Strg-Taste"
        End Select
    End Sub

End Class

